
.include "m32def.inc"     // Includem fisirul 

; definirea unei constante
 .equ MCU_FREQ	=   10000000
 .equ TIME_CONST =  MCU_FREQ/256/1000
 .equ const		=	3000/19*56
 .equ const1	=	256

 .equ LedRED 	= PD3
 .equ LEDGreen 	= PD5
 .equ Button 	= PD6


; redefinirea registrilor
 .def tmpH  = r16
 .def tmpL  = r17
 .def aL 	= r18
 .def aH 	= r19
 .def counter = r5

 .def flags = r2

 

.dseg	; segmentul de date
.org 0x72		; sa plaseze variabila pe adresa 0x72
myvar:	.byte 1
var2:	.byte 1

.cseg	; segmentul de cod 
.org	0x0000
	rjmp	Reset	; Salt neconditionat

.org	INT0addr	; External Interrupt0 Vector Address
	reti
.org	INT1addr	; External Interrupt1 Vector Address
	rjmp INT1_ISR	; Salt neconditionat la Subrutina de intrerupere

.org	INT2addr	; External Interrupt2 Vector Address
	reti
.org	OC2addr	    ; Output Compare2 Interrupt Vector Address
	reti 
.org	OVF2addr	; Overflow2 Interrupt Vector Address
	reti
.org	ICP1addr	; Input Capture1 Interrupt Vector Address
	reti
.org	OC1Aaddr	; Output Compare1A Interrupt Vector Address
	reti
.org	OC1Baddr	; Output Compare1B Interrupt Vector Address
	reti
.org	OVF1addr	; Overflow1 Interrupt Vector Address
	reti
.org	OC0addr	    ; Output Compare0 Interrupt Vector Address
	reti
.org	OVF0addr	; Overflow0 Interrupt Vector Address
	reti
.org	SPIaddr	     ; SPI Interrupt Vector Address
	reti
.org	URXCaddr	; USART Receive Complete Interrupt Vector Address
	reti
.org	UDREaddr	; USART Data Register Empty Interrupt Vector Address
	reti
.org	UTXCaddr	; USART Transmit Complete Interrupt Vector Address
	reti
.org	ADCCaddr	; ADC Interrupt Vector Address
	reti
.org	ERDYaddr	; EEPROM Interrupt Vector Address
	reti
.org	ACIaddr 	; Analog Comparator Interrupt Vector Address
	reti
.org    TWIaddr   ; Irq. vector address for Two-Wire Interface
	reti
.org	SPMRaddr	; Store Program Memory Ready Interrupt Vector Address
	reti

//---------------------------------------------------------------
INT1_ISR:    ;Subrutina de prelucrare a intreruperii
	in flags, SREG		; memorizam temporar flagurile
 		; comenzi pentru subruta data

		
	 out SREG, flags	; restabilim fanioanele
	 reti

; Programul principal
//--------------------------------------------------------------	 
RESET:	 
     ldi tmpL, Low(RAMEND) 	; initializam stiva
	 out SPL, tmpL
	 ldi tmpH, High(RAMEND) 
	 out SPH, tmpH
 
	 CLR tmpL				;resetam tmpl
	 out DDRA, tmpL			; Setam ca intrare PORTA

	 ldi tmpL, (1<<LedRED) | (1<<LedGreen) 	; Pin3 si 5 ca output, restu  - input	1<<3
	 out DDRD, tmpL			; Setam ca intrare PORTD
	 ldi tmpL, ~((1<<LedRED) | (1<<LedGreen))
	 out PORTD, tmpL


	 ldi tmpL, 0xff			 	
	 out DDRB, tmpL			; Setam ca iesire PORTB	 
	 out DDRC, tmpL			; Setam ca iesire PORTC
	
	


	/*
	PORTA = 0xff;


	ldi R0, 0xFF
	out PORTA, R0


	SBI PORTC, 3

	PORTC |= (1<<3); 
	*/

 MAIN: ; programul principal
 	sbi PORTD, LedGreen
	cbi PORTD, LedRED
	rcall delay
   	in tmpL, PINA	; citim datele din PINA	 

	clr tmpH		; implicit resetam High
	sbrc tmpL, 7	; analizam bitu semnului la Low
	ser tmpH		; si daca e negativ - extindem high cu unitati


	ldi tmpH, 5 ;incarcam const 5 	
	muls tmpL, tmpH ; inmultim registrii
	
	ldi aL, LOW(const1) ;incarcam octetul inferior al const 
	ldi aH, High(const1);incarcam octetul superior al const 
	
	add aL,r0; adunam registrii inf
	adc aH,r1; adunam partea super cu transportul

	sbis PIND, button
	rjmp skip

 	cbi PORTD, LedGreen
	sbi PORTD, LedRED
skip:

	rcall delay
	
	asr aH ; deplasam la dreapta cu o pozitie aritmetic
	ror aL ; deplasam oct inf
	asr aH ; deplasam la dreapta cu o pozitie aritmetic
	ror aL ; deplasam oct inf

	ldi tmpL, LOW(const) ;incarcam const 3000 in tmpL
	ldi tmpH, High(const)

	sub aL, tmpL; scadem din reg aL const
	sbc aH, tmpH; scadem partea super cu transp

	out PORTC, aL
	out PORTB, aH

	nop




	RJMP MAIN


// Subrutina care genereaza o pauza
delay:
	ldi tmpl, 150
 extloop:
 	ldi tmpH, 200
	intloop:
 	nop
	dec tmpH
	brne intloop
	dec tmpL
	brne extloop
	ret

Tabel: 
 .dw 0x00FA
